#!/usr/bin/perl -w
#Author: liangfang
# submit a list of jobs to PBS
my $version=1.00;

use strict;
use Getopt::Long;
my %opts;
GetOptions(\%opts,"i=s","r=s","h");
if (!(defined $opts{i}) || defined $opts{h}) { #necessary arguments
&usage;
}

my $in = $opts{'i'};
my $r = defined $opts{'r'} ? $opts{'r'} : 'n';

sub usage{
print <<"USAGE";
Version $version
Usage:
$0 -i -r
options:
-i input file containing a list of jobs or a dir containing a list of R scripts
-r if these are R scripts, "y" or "n", [n]
-h help
USAGE
exit(1);
}

#1       /share_bio/panfs_bio/bioinformatics/lirj/liangf/meth_rice/filter_rice/rice-b/depc/scripts/chr01_C-T.sh
#2       /share_bio/panfs_bio/bioinformatics/lirj/liangf/meth_rice/filter_rice/rice-b/depc/scripts/chr01_G-A.sh
#3       /share_bio/panfs_bio/bioinformatics/lirj/liangf/meth_rice/filter_rice/rice-b/depc/scripts/chr02_C-T.sh

if ($r eq 'n') {
	open IN, "$in" or die "Sorry, can't open file $in";
	while (<IN>){
		s/\s+$//;
		my ($n, $j) = split;
		system("sh $j &");
		print "$j\n";
		sleep 1;
	}
	close IN;
} elsif ($r eq 'y'){
	system "chmod 755 $in/chr*.R";
	my $samm;
	opendir R, "$in" or die "Sorry, can't open directory $in";
	while ($samm = readdir R) {
		if ($samm !~ /^\./ and $samm =~ /chr.*R$/) {
			system "R CMD BATCH $in/$samm &";
			print "$samm submitted!\n";
			sleep 1;
		}
	}
	closedir R;
} else {
	die "-r should be \'y\' or \'n\'\n";
}